package com.eactive.eai.batch.job.jobItem.kofc;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KOFCB_0300 extends DefaultTelegram implements TelegramService
{

    private int     SEQUENCE_NO;
    private int     SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int     REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private int     MISSING_COUNT;     //결번갯수
    private String  MISSING_FIELD;

    private Properties telegramInfo;
    private FileOutputStream fout;

    /**
     * 생성자
     */
    public SEND_KOFCB_0300() {
        //결번확인통보
        MISSING_COUNT = 0;
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            SEQUENCE_NO = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            boolean result = calculateMissingCount();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(1, "" + SEND_LENGTH, this.al_FieldProps[1]);

            //업무구분코드 - 센터 및 은행에서 업무구분을 위하여 SET
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            //거래구분코드 "R"-센터 수신 업무, "S"-센터 송신업무
            //compileField(5, this.getFldTrClass(), this.al_FieldProps[5]);
            //기관별로 송수신시 사용되는 거래구분코드가 상이하여 기관별 속성값에서 참조하도록 함.
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                 procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_SEND), this.al_FieldProps[5]);
            }else{
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_RECV), this.al_FieldProps[5]);
            }
            //송수신 FLAG "C"-센터에서 전문을 발생할 시, "B"-은행에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            //화일명
            compileField(7, batchDoc.getBatchMsg().getHeader().getFileName(), this.al_FieldProps[7]);
            //응답코드
            compileField(8, this.getSendResponseCode(), this.al_FieldProps[8]);
            //BLOCK-NO
            compileField(9, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum(), this.al_FieldProps[9]);
            //최종 SEQUENCE-NO
            compileField(10, ""+SEQUENCE_NO, this.al_FieldProps[10]);
            //결번갯수
            compileField(11, ""+MISSING_COUNT, this.al_FieldProps[11]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            // 20060413 add by khs
            if (MISSING_COUNT==0) {
                fout.close();
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size()-1; i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int fieldLen = -1;
        String propKey = "";
        switch (idx) {
        case 0:
            propKey = TelegramKeys.TRCD_LEN;
            break;

        case 3:
            propKey = TelegramKeys.ORGN_CD_LEN;
            break;

        case 12:
            return MISSING_FIELD.length();

        default:
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        try {
            fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );

        } catch (Exception e) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = propKey;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }

        return fieldLen;
    }
    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
        	if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            switch (idx) {

            case 0:
                // TR 코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );

                break;
            case 3:
                // 기관코드
                System.arraycopy((telegramInfo.getProperty(TelegramKeys.BANK_CODE) + "          ").getBytes(), 0, data, 0, fldLen );

                break;
            case 12:
                //mod by khs data = MISSING_FIELD.getBytes();
                ByteArrayInputStream bin = new ByteArrayInputStream(MISSING_FIELD.getBytes());
                bin.read(data, 0, MISSING_FIELD.length());
                return MISSING_FIELD.length();

            default:
                break;
            }

            // 로깅을 위해
            byte[] fieldData = new byte[fldLen];
            System.arraycopy(data, 0, fieldData, 0, fldLen);
            this.al_Field.set( idx, fieldData);
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=2; i< this.al_Field.size()-1; i++) { //마지막 결번확인은 가변길이
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += MISSING_FIELD.length();  //비정형 필드인 결번확인의 길이 더함.

            SEND_LENGTH += ( getCalculatedLength(3) - 1 );
            REAL_SEND_LENGTH = SEND_LENGTH + getCalculatedLength(0) + ((byte[]) this.al_Field.get(1)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

        return true;
    }

    private boolean calculateMissingCount () {
        try {

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            byte[] _missingNm = new byte[seq_no];
            for (int i=0; i<seq_no; i++) {
                _missingNm[i] = '1';    //모든 결번은 1로 초기화
            }

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            if (block_data == null ){
                MISSING_COUNT = SEQUENCE_NO;
                for (int i = 0; i<SEQUENCE_NO; i++)
                    _missingNm[i] = '0';
            }else{
                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인
                    byte[] data = (byte[]) block_data.get( new Integer(i) );
                    if (data == null ) {
                        _missingNm[i] = '0';    //결번이 발생한 seq만 '0' 설정
                        MISSING_COUNT++;
                        logger.info("{} calculateMissingCount >> missing telegram : [" + i + "]", logHeader);
                    }
                }
            }

            if (MISSING_COUNT == 0) {
                if (!createFile()) {
                    return false;
                }

                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                    byte[] data = (byte[]) block_data.get(new Integer(i));
                    int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                    if ( recLen < 1 ){
                    	recLen = data.length;
                    }
                    byte[]layout = new byte[recLen];
                    for (int inx = 0; inx < layout.length; inx++) {
                        layout[inx] = ' ';
                    }

                    int dataCnt = data.length / recLen ;
                    for (int jnx = 0; jnx < dataCnt; jnx++) {
                        System.arraycopy( data,jnx*layout.length,layout,0,layout.length);
                        // 수신한 DATA에서 각 RECORD 마지막에 개행문자가 포함된 경우 SPACE로 변경
                        // 2013.04.16 이해승 차장님 Confirm
                        if ( layout[recLen-2] == '\r' || layout[recLen-2] == '\n' ){
                        	layout[recLen-2] = ' ';
                        }
                        if ( layout[recLen-1] == '\r' || layout[recLen-1] == '\n' ){
                        	layout[recLen-1] = ' ';
                        }
                        fout.write(layout);
                        fout.write( '\n' );
                        long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                        batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
                    }

                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 Vector 초기화
            }

            this.MISSING_FIELD = new String (_missingNm);
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(MISSING_COUNT);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(MISSING_FIELD);

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getRenamedFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            File file = new File(strFullPath);
            fout = new FileOutputStream(file, true);   //bytes will be written to the end of the file rather than the beginning
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}